/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.services.print.printsinkimpl;

import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataSet;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConstants;

/**
 *  This class contains the Attributes required for Query Model. Also contains methods to populate and fill dataset of Query Model.
 */
public class NSetAnnotationBoxAttributes extends Attributes
{
	
	/**
	 * This is default Constructor for NSetAnnotationBoxAttributes.
	 */
	public NSetAnnotationBoxAttributes() {
		super();
	}

	/**
	 * Sets the position of the annotation box in the parent film box.
	 * 
	 * @param sAnnotationPosition short value of Annotation Position.
	 */
	public void setAnnotationPosition(short sAnnotationPosition)
	{
		/* Accept Annotation Position in short format of type US.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create.
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		addDataElement(0x2030, 0x0010, DicomConstants.DCM_DT_US, sAnnotationPosition);
	}

	/**
	 * Retrieves the position of the annotation box in the parent film box.
	 * 
	 * @return short - short value of Annotation Position.
	 */
	public short getAnnotationPosition()
	{
		Object objValue = getValue(0x2030,0x0010);
		if(objValue != null)
			return Short.parseShort(objValue.toString());
		return DicomConstants.DCM_NO_VALUE;
	}
	
	/**
	 * Sets Text string.
	 * 
	 * @param strTextString String value of Text string.
	 */
	public void setTextString(String strTextString)
	{
		/* Accept Text String format of type LO.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create.
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Hash Map
		 */
		addDataElement(0x2030, 0x0020, DicomConstants.DCM_DT_LO, strTextString);
	}

	/**
	 * Retrieves Text string.
	 * 
	 * @return String - String value of Text string.
	 */
	public String getTextString()
	{
		Object objValue = getValue(0x2030,0x0020);
		if(objValue != null)
			return objValue.toString();
		return null;
	}
	
	/**
	 * Populates the query Model using filled dataset.
	 */
	public void populate(IDataSet objIDataSet)
	{
		super.populate(objIDataSet);
	}	
	
	/**
	 * Fills the dataset using already populated Query Model.
	 */
	public void fill(IDataSet objIDataSet)
	{
		super.fill(objIDataSet);
	}
}
